<!-- TITLE -->
<div class="mb-40 mt-40">
    <h1>Edit User</h1>
</div>

<div class="card">
    <div class="card-body">
        <form #editForm="ngForm" *ngIf="user">
            <div class="row justify-content-md-center">
                <div class="col-md-10">
                    <div class="form-group">
                        <label for="correo">correo</label>
                        <input type="text" class="form-control" id="correo" [(ngModel)]="user.correo" name="correo" #username="ngModel" required [disabled]="user.idUser!==-1">
                    </div>

                    <div class="form-group">
                        <label for="username">apellidos</label>
                        <input type="string" class="form-control" id="apellidos" [(ngModel)]="user.apellidos" name="apellidos" #apellidos="ngModel" >
                    </div>

                    <div class="form-group">
                        <label for="username">contrasenia</label>
                        <input type="string" class="form-control" id="contrasenia" [(ngModel)]="user.contrasenia" name="contrasenia" #contrasenia="ngModel" reqired>
                    </div>
                    <div class="form-group">
                        <label for="username">correo</label>
                        <input type="string" class="form-control" id="correo" [(ngModel)]="user.correo" name="correo" #correo="ngModel" >
                    </div>



                    <div class="form-group">
                        <label for="username">nombres</label>
                        <input type="string" class="form-control" id="nombres" [(ngModel)]="user.nombres" name="nombres" #nombres="ngModel" >
                    </div>


                    <div class="form-group" *ngIf="!user.idUser">
                        <label for="name">Password</label>
                        <input type="password" class="form-control" id="password" [(ngModel)]="user!.contrasenia" name="password" #password="ngModel" required>
                    </div>
                    <div class="form-group" *ngIf="!user.idUser">
                        <label for="name">Password confirm</label>
                        <input type="password" class="form-control" id="passwordConfirm" [(ngModel)]="user.passwordNewConfirm" name="passwordConfirm" #passwordConfirm="ngModel" required>
                    </div>
                    <!-- ROLE MANAGEMENT -->
                    <h3>Roles</h3>
                    <div class="row">
                        <div class="form-group col-12">
                            <label for="name">New role...</label>
                            <input type="text" class="form-control" id="newRole" name="newRole" #newRole>
                        </div>
                        <div class="col-12">
                            <span class="btn btn-primary text-center pull-right mb-20" (click)="addRole(newRole)">
                                <i class="fa fa-plus"></i>
                            </span>
                        </div>
                    </div>
                    <!-- NO ROLES -->
                    <label *ngIf="!user.perfiles || user.perfiles.length===0">
                        No roles assigned to user
                    </label>
                    <!-- NO ROLES -->
                    <div *ngFor="let role of user.perfiles; let i = index; trackBy:trackByFn" class="row mt-2">
                        <div class="form-group" class="col-11">
                            <input type="text" class="form-control" id="role{{i}}" [(ngModel)]="user.perfiles![i]" name="roles{{i}}">
                        </div>
                        <span class="btn btn-danger text-center col-1" (click)="removeRole(i)">
                            <i class="fa fa-trash"></i>
                        </span>
                    </div>
                    <div class="mt-40">
                        <button class="btn btn-info" *ngIf="user.idUser" data-toggle="modal" data-target="#changePasswordModal">Change Password</button>
                        <button class="btn btn-primary pull-right" color="primary" [disabled]="editForm.invalid" (click)="save()">Save</button>
                        <button class="btn btn-secondary pull-right mr-2" routerLink="/manage-users">Back To User List</button>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>

<!-- Modal -->
<div class="modal fade" id="changePasswordModal" tabindex="-1" role="dialog" aria-labelledby="deleteModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLabel"><i class="fa fa-lock"></i>&nbsp;&nbsp;Change password</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
            </div>
            <form #changePasswordForm="ngForm" class="container-fluid">
                <div class="modal-body">
                    <div class="row justify-content-md-center">
                        <div class="col-10">
                            <div class="form-group">
                                <label for="passwordAdmin">Password Admin</label>
                                <input type="password" class="form-control" id="passwordAdmin" [(ngModel)]="passwordAdmin" name="passwordAdmin" #passwordAdminForm="ngModel" required>
                            </div>
                            <div class="form-group">
                                <label for="passwordNew">New Password</label>
                                <input type="password" class="form-control" id="passwordNew" [(ngModel)]="passwordNew" name="passwordNew" #passwordNewForm="ngModel" required>
                            </div>
                            <div class="form-group">
                                <label for="passwordNewConfirm">Confirm New Password</label>
                                <input type="password" class="form-control" id="passwordNewConfirm" [(ngModel)]="passwordNewConfirm" name="passwordNewConfirm" #passwordNewConfirmForm="ngModel" [ngClass]="{'is-invalid': passwordNew && passwordNewConfirm && passwordNew !== passwordNewConfirm}"
                                    required>
                                <p *ngIf="passwordNew && passwordNewConfirm && passwordNew !== passwordNewConfirm" class="help-block">Passwords missmatch</p>
                            </div>
                        </div>
                    </div>
                </div>
            </form>
            <div *ngIf="showError" class="row justify-content-md-center">
                <div class="alert alert-danger text-left">
                    <strong>Error!</strong> Admin passsword not valid
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" #closeModal class="btn btn-default" data-dismiss="modal">Cancel</button>
                <button type="button" class="btn btn-primary" [disabled]="changePasswordForm.invalid || (passwordAdmin && passwordNewConfirm && passwordNew !== passwordNewConfirm)" (click)="changePassword()">Save</button>
            </div>
        </div>
    </div>
</div>
